//: [Previous](@previous)

import Foundation

class Vehicle {
    
    // A class also lets me store different kinds of data in one holder.
    // It's different, because I _have_ to initialize a Class.
    // I didn't have to initialize the Structure.
    // When I create a structure, I'm just describing what the data
    // will look like, and the data doesn't exist until I put it
    // into a variable.
    // A Class isn't that flexible. You have to give it initializers
    // So it needs to have an idea of what's going to be in there.
    enum Kind: Int {
        case car, truck, motorcycle, bicycle, moped
        func wheels() -> Int {
            switch self {
            case .car, .truck:
                return 4
            default:
                return 2
            }
        }
    }
    
    enum Condition: Int {
        case great, good, fair, bad, wreck
    }

    var type: Kind = .car
    // What kind of vehicle is it?
    var condition: Condition = .fair
    // What is it's condition?
    var tank: Float = 10
    // How much gas does it hold?
}

var honda = Vehicle()
print(honda.type)
print(honda.condition)
print(honda.tank)
print("My honda has \(honda.type.wheels()) wheels.")
honda.type = .car
print("If it's a ", terminator: "")
if honda.type == Vehicle.Kind.motorcycle {
    print("motorcycle ", terminator: "")
} else {
    print("not a motorcycle ", terminator: "")
}
print("I have \(honda.type.wheels()) wheels.")
