//: [Previous](@previous)

import Foundation

var say = ["dog": "bark", "cat": "meow"]
// This is a dictionary.
// So each value has a key.
// the value of "bark" has a key "dog"
print(say)

say["cow"] = "moo"
// Hey, I added a new entry to my dictionary! That's neat!

print(say)

let sound = say["dog"]
// so I'm looking for the answer to the key "dog" in dictionary "say"
// what kind of variable is sound?
// If you said "String", you're only partly right.
print(sound)
// How come it didn't just say "bark"?
// This is an optional. Optionals are complicated. Any
// variable could concievably be an optional. Optional Ints, Optional
// Strings.
// You will see optionals all over Swift.
// An optional means that I might not have anything in this variable.
// If I do, I'll tell you whats in there.
// If I don't, I'll tell you it's empty.

func what(does animals: [String:String], the animal: String) {
    // Wow, that's a mouthful.
    // so I've remapped both of the variables.
    // the world sees "does",
    // but I'm using "animals" internally
    // and the world sees "the",
    // but I'm using "animal" internally
    // One of the variables (animals) is a Dictionary ([String:String])
    // The other one (animal) is a String
    
    // Could I have renamed these internal variables to be something clearer?
    // right now, the variables are "animals" and "animal" internally.
    // for sake of argument, lets say I'm the only one who's going to
    // see that.
    
    // In a month, are those variables going to make sense to me?
    
    if let says = animals[animal] {
        // Ok, I know what an if is, but what's happening here?
        // this is an optional assignment.
        // You'll see this all over Swift. It's saying, hey, if
        // there is information in animals[animal] put it in "says".
        // If not, then move on.
        print("The " + animal + " says " + says + ".")
            // shouldn't be anything shocking in this line
    } else {
        // This means there was nothing in animals[animal]
        // how could this happen? After all, we put information
        // into the dictionary, right?
        // What if I ask the dictionary to find something
        // I didn't put in there?
        print("I don't know what the " + animal + " says.")
            // nothing surprising here.
    }
}


what(does: say, the: "cat")
// Well, of course we know what the cat says.
// After all, we put that in the dictionary.

what(does: say, the: "fox")
// What does the fox say?

// ok, we coded around that. We looked to see if we knew what
// a fox said before we did anything.
// If we hadn't checked, the compiler would have stopped us,
// or the program would have crashed when we ran it.
