//: [Previous](@previous)

import Foundation

struct Vehicle {
    
    // A structure lets me store different kinds of data in one holder.
    // So I can keep everything related to it in one place.
    // I have a special enum that's in my structure. Because it's defined
    // in the Structure, is only available here. No other code will understand
    // this enum.
    enum Kind: Int {
        case car, truck, motorcycle, bicycle, moped
        
        // and my enum has function. it's going to tell you how many
        // wheels I have, depending on what I am.
        // What happens if I extend this?
        func wheels() -> Int {
            switch self {
            case .car, .truck:
                return 4
            default:
                return 2
            }
        }
    }
    
    enum Condition: Int {
        case great, good, fair, bad, wreck
    }
    // Here's another enum. This just keeps track of the condition of my
    // car
    
    
    // Finally, I'm going to tell you what kind of variables are
    // in my car.
    var type: Kind
    // What kind of vehicle is it?
    var condition: Condition
    // What is it's condition?
    var tank: Float
    // How much gas does it hold?
}

let honda = Vehicle(type: .car, condition: .fair, tank: 12.5)

print("My honda has \(honda.type.wheels()) wheels.")
